commit 09831707ce65606f951c97632d882f083ad3ed02
Author: Jason Merrill <jason@redhat.com>
Date:   Mon May 25 18:38:09 2020 -0400

    c++: -fmerge-all-constants vs. destructors [PR91529]
    
    cp_finish_decl avoids setting TREE_READONLY on TREE_STATIC variables that
    have non-constant construction or destruction, but -fmerge-all-constants was
    converting an automatic variable to static while leaving TREE_READONLY set.
    
    Fixed by clearing the flag in cp_finish_decl in the presence of
    -fmerge-all-constants.
    
    gcc/cp/ChangeLog
    2020-05-01  Jason Merrill  <jason@redhat.com>
    
            PR c++/91529
            * decl.c (cp_finish_decl): Also clear TREE_READONLY if
            -fmerge-all-constants.

diff --git a/gcc/cp/decl.c b/gcc/cp/decl.c
index 5642791446f..f2b52fb674e 100644
--- a/gcc/cp/decl.c
+++ b/gcc/cp/decl.c
@@ -7250,7 +7250,10 @@ cp_finish_decl (tree decl, tree init, bool init_const_expr_p,
       /* This needs to happen after the linkage is set. */
       determine_visibility (decl);
 
-      if (var_definition_p && TREE_STATIC (decl))
+      if (var_definition_p
+	  /* With -fmerge-all-constants, gimplify_init_constructor
+	     might add TREE_STATIC to the variable.  */
+	  && (TREE_STATIC (decl) || flag_merge_constants >= 2))
 	{
 	  /* If a TREE_READONLY variable needs initialization
 	     at runtime, it is no longer readonly and we need to
diff --git a/gcc/testsuite/g++.dg/init/const14.C b/gcc/testsuite/g++.dg/init/const14.C
new file mode 100644
index 00000000000..f29c7e58cfc
--- /dev/null
+++ b/gcc/testsuite/g++.dg/init/const14.C
@@ -0,0 +1,14 @@
+// PR c++/91529
+// { dg-do run }
+// { dg-additional-options -fmerge-all-constants }
+
+struct A
+{
+  int i[2];
+  ~A() { i[0] = 0; }
+};
+
+int main()
+{
+  const A a = { 1,2 };
+}

